Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15032)
@@ -24,5 +24,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.SWAP")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.SWAP",
+    "Swaps the top two items on the stack.")]
   public class IntegerSwapExpression : SwapExpression<long> {
     public IntegerSwapExpression() { }
@@ -40,5 +43,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.SWAP")]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.SWAP",
+    "Swaps the top two items on the stack.")]
   public class FloatSwapExpression : SwapExpression<double> {
     public FloatSwapExpression() { }
@@ -56,5 +62,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.SWAP")]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.SWAP",
+    "Swaps the top two items on the stack.")]
   public class BooleanSwapExpression : SwapExpression<bool> {
     public BooleanSwapExpression() { }
@@ -72,5 +81,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.SWAP")]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.SWAP",
+    "Swaps the top two items on the stack.")]
   public class NameSwapExpression : SwapExpression<string> {
     public NameSwapExpression() { }
@@ -88,5 +100,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.SWAP", execIn: 2)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.SWAP",
+    "Swaps the top two items on the stack.",
+    execIn: 2)]
   public class ExecSwapExpression : SwapExpression<Expression> {
     public ExecSwapExpression() { }
@@ -104,5 +120,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.SWAP")]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.SWAP",
+    "Swaps the top two items on the stack.")]
   public class CodeSwapExpression : SwapExpression<Expression> {
     public CodeSwapExpression() { }
@@ -120,5 +139,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.SWAP")]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.SWAP",
+    "Swaps the top two items on the stack.")]
   public class CharSwapExpression : SwapExpression<char> {
     public CharSwapExpression() { }
@@ -136,5 +158,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.SWAP")]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.SWAP",
+    "Swaps the top two items on the stack.")]
   public class StringSwapExpression : SwapExpression<string> {
     public StringSwapExpression() { }
@@ -152,5 +177,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].SWAP")]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].SWAP",
+    "Swaps the top two items on the stack.")]
   public class IntegerVectorSwapExpression : SwapExpression<IReadOnlyList<long>> {
     public IntegerVectorSwapExpression() { }
@@ -168,5 +196,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].SWAP")]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].SWAP",
+    "Swaps the top two items on the stack.")]
   public class FloatVectorSwapExpression : SwapExpression<IReadOnlyList<double>> {
     public FloatVectorSwapExpression() { }
@@ -184,5 +215,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].SWAP")]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].SWAP",
+    "Swaps the top two items on the stack.")]
   public class BooleanVectorSwapExpression : SwapExpression<IReadOnlyList<bool>> {
     public BooleanVectorSwapExpression() { }
@@ -200,5 +234,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].SWAP")]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].SWAP",
+    "Swaps the top two items on the stack.")]
   public class StringVectorSwapExpression : SwapExpression<IReadOnlyList<string>> {
     public StringVectorSwapExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15032)
@@ -30,5 +30,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].BUTLAST")]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].BUTLAST",
+    "Takes the rest of the top item on the INTEGER[] stack.")]
   public class IntegerVectorButLastExpression : VectorButLastExpression<long> {
     public IntegerVectorButLastExpression() { }
@@ -46,5 +49,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].BUTLAST")]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].BUTLAST",
+    "Takes the rest of the top item on the FLOAT[] stack.")]
   public class FloatVectorButLastExpression : VectorButLastExpression<double> {
     public FloatVectorButLastExpression() { }
@@ -62,5 +68,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].BUTLAST")]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].BUTLAST",
+    "Takes the rest of the top item on the BOOLEAN[] stack.")]
   public class BooleanVectorButLastExpression : VectorButLastExpression<bool> {
     public BooleanVectorButLastExpression() { }
@@ -78,5 +87,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].BUTLAST")]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].BUTLAST",
+    "Takes the rest of the top item on the STRING[] stack.")]
   public class StringVectorButLastExpression : VectorButLastExpression<string> {
     public StringVectorButLastExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15032)
@@ -8,5 +8,5 @@
 
   /// <summary>
-  /// Concats two vectors on the type stack.
+  /// Concatinates two vectors on the type stack.
   /// </summary>
   [StorableClass]
@@ -33,5 +33,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].CONCAT")]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].CONCAT",
+    "Concatenates the top two vectors on the INTEGER[] stack.")]
   public class IntegerVectorConcatExpression : VectorConcatExpression<long> {
     public IntegerVectorConcatExpression() { }
@@ -49,5 +52,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].CONCAT")]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].CONCAT",
+    "Concatenates the top two vectors on the FLOAT[] stack.")]
   public class FloatVectorConcatExpression : VectorConcatExpression<double> {
     public FloatVectorConcatExpression() { }
@@ -65,5 +71,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].CONCAT")]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].CONCAT",
+    "Concatenates the top two vectors on the BOOLEAN[] stack.")]
   public class BooleanVectorConcatExpression : VectorConcatExpression<bool> {
     public BooleanVectorConcatExpression() { }
@@ -81,5 +90,8 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].CONCAT")]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].CONCAT",
+    "Concatenates the top two vectors on the STRING[] stack.")]
   public class StringVectorConcatExpression : VectorConcatExpression<string> {
     public StringVectorConcatExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15032)
@@ -29,5 +29,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].CONJ", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].CONJ",
+    "Conj's the top INTEGER onto the top item of the INTEGER[] stack.",
+    StackTypes.Integer)]
   public class IntegerVectorConjExpression : VectorConjExpression<long> {
     public IntegerVectorConjExpression() { }
@@ -45,5 +49,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].CONJ", StackTypes.Float)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].CONJ",
+    "Conj's the top FLOAT onto the top item of the FLOAT[] stack.",
+    StackTypes.Float)]
   public class FloatVectorConjExpression : VectorConjExpression<double> {
     public FloatVectorConjExpression() { }
@@ -61,5 +69,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].CONJ", StackTypes.String)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].CONJ",
+    "Conj's the top STRING onto the top item of the STRING[] stack.",
+    StackTypes.String)]
   public class StringVectorConjExpression : VectorConjExpression<string> {
     public StringVectorConjExpression() { }
@@ -77,5 +89,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].CONJ", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].CONJ",
+    "Conj's the top BOOLEAN onto the top item of the BOOLEAN[] stack.",
+    StackTypes.Boolean)]
   public class BooleanVectorConjExpression : VectorConjExpression<bool> {
     public BooleanVectorConjExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15032)
@@ -34,5 +34,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].CONTAINS", StackTypes.Integer | StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].CONTAINS",
+    "Tells whether the top INTEGER is in the top INTEGER[].",
+    StackTypes.Integer | StackTypes.Boolean)]
   public class IntegerVectorContainsExpression : VectorContainsExpression<long> {
     public IntegerVectorContainsExpression() { }
@@ -50,5 +54,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].CONTAINS", StackTypes.Float | StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].CONTAINS",
+    "Tells whether the top FLOAT is in the top FLOAT[].",
+    StackTypes.Float | StackTypes.Boolean)]
   public class FloatVectorContainsExpression : VectorContainsExpression<double> {
     public FloatVectorContainsExpression() { }
@@ -66,5 +74,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].CONTAINS", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].CONTAINS",
+    "Tells whether the top BOOLEAN is in the top BOOLEAN[].",
+    StackTypes.Boolean)]
   public class BooleanVectorContainsExpression : VectorContainsExpression<bool> {
     public BooleanVectorContainsExpression() { }
@@ -82,5 +94,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].CONTAINS", StackTypes.String | StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].CONTAINS",
+    "Tells whether the top STRING is in the top STRING[].",
+    StackTypes.String | StackTypes.Boolean)]
   public class StringVectorContainsExpression : VectorContainsExpression<string> {
     public StringVectorContainsExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15032)
@@ -28,5 +28,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].EMPTYVECTOR", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].EMPTYVECTOR",
+    "Pushes a BOOLEAN of whether the top INTEGER[] is empty.",
+    StackTypes.Boolean)]
   public class IntegerVectorEmptyVectorExpression : VectorEmptyVectorExpression<long> {
     public IntegerVectorEmptyVectorExpression() { }
@@ -44,5 +48,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].EMPTYVECTOR", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].EMPTYVECTOR",
+    "Pushes a BOOLEAN of whether the top FLOAT[] is empty.",
+    StackTypes.Boolean)]
   public class FloatVectorEmptyVectorExpression : VectorEmptyVectorExpression<double> {
     public FloatVectorEmptyVectorExpression() { }
@@ -60,5 +68,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].EMPTYVECTOR", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].EMPTYVECTOR",
+    "Pushes a BOOLEAN of whether the top BOOLEAN[] is empty.",
+    StackTypes.Boolean)]
   public class BooleanVectorEmptyVectorExpression : VectorEmptyVectorExpression<bool> {
     public BooleanVectorEmptyVectorExpression() { }
@@ -76,5 +88,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].EMPTYVECTOR", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].EMPTYVECTOR",
+    "Pushes a BOOLEAN of whether the top STRING[] is empty.",
+    StackTypes.Boolean)]
   public class StringVectorEmptyVectorExpression : VectorEmptyVectorExpression<string> {
     public StringVectorEmptyVectorExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15032)
@@ -28,5 +28,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].FIRST", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].FIRST",
+    "Pushes the first INTEGER of the top INTEGER[].",
+    StackTypes.Integer)]
   public class IntegerVectorFirstExpression : VectorFirstExpression<long> {
     public IntegerVectorFirstExpression() { }
@@ -44,5 +48,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].FIRST", StackTypes.Float)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].FIRST",
+    "Pushes the first FLOAT of the top FLOAT[].",
+    StackTypes.Float)]
   public class FloatVectorFirstExpression : VectorFirstExpression<double> {
     public FloatVectorFirstExpression() { }
@@ -60,5 +68,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].FIRST", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].FIRST",
+    "Pushes the first BOOLEAN of the top BOOLEAN[].",
+    StackTypes.Boolean)]
   public class BooleanVectorFirstExpression : VectorFirstExpression<bool> {
     public BooleanVectorFirstExpression() { }
@@ -76,5 +88,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].FIRST", StackTypes.String)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].FIRST",
+    "Pushes the first BOOLEAN of the top BOOLEAN[].",
+    StackTypes.String)]
   public class StringVectorFirstExpression : VectorFirstExpression<string> {
     public StringVectorFirstExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15032)
@@ -43,5 +43,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].INDEXOF", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].INDEXOF",
+    "Pushes the index of the top INTEGER in the top INTEGER[] onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class IntegerVectorIndexOfExpression : VectorIndexOfExpression<long> {
     public IntegerVectorIndexOfExpression() { }
@@ -59,5 +63,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].INDEXOF", StackTypes.Float | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].INDEXOF",
+    "Pushes the index of the top FLOAT in the top FLOAT[] onto the INTEGER stack.",
+    StackTypes.Float | StackTypes.Integer)]
   public class FloatVectorIndexOfExpression : VectorIndexOfExpression<double> {
     public FloatVectorIndexOfExpression() { }
@@ -75,5 +83,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].INDEXOF", StackTypes.Boolean | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].INDEXOF",
+    "Pushes the index of the top BOOLEAN in the top BOOLEAN[] onto the INTEGER stack.",
+    StackTypes.Boolean | StackTypes.Integer)]
   public class BooleanVectorIndexOfExpression : VectorIndexOfExpression<bool> {
     public BooleanVectorIndexOfExpression() { }
@@ -91,5 +103,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].INDEXOF", StackTypes.String | StackTypes.String)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].INDEXOF",
+    "Pushes the index of the top STRING in the top STRING[] onto the INTEGER stack.",
+    StackTypes.String | StackTypes.Integer)]
   public class StringVectorIndexOfExpression : VectorIndexOfExpression<string> {
     public StringVectorIndexOfExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15032)
@@ -62,5 +62,10 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].ITERATE", StackTypes.Integer | StackTypes.Exec, execIn: 1)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].ITERATE",
+    "Iterates in reverse order (due to performance reasons) over the top INTEGER[] using the top item of the EXEC stack.",
+    StackTypes.Integer | StackTypes.Exec,
+    execIn: 1)]
   public class IntegerVectorIterateExpression : VectorIterateExpression<long> {
     public IntegerVectorIterateExpression() { }
@@ -78,5 +83,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].ITERATE", StackTypes.Float | StackTypes.Exec, execIn: 1)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].ITERATE",
+    "Iterates in reverse order (due to performance reasons) over the top FLOAT[] using the top item of the EXEC stack.",
+    StackTypes.Float | StackTypes.Exec, execIn: 1)]
   public class FloatVectorIterateExpression : VectorIterateExpression<double> {
     public FloatVectorIterateExpression() { }
@@ -94,5 +103,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].ITERATE", StackTypes.Boolean | StackTypes.Exec, execIn: 1)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].ITERATE",
+    "Iterates in reverse order (due to performance reasons) over the top BOOLEAN[] using the top item of the EXEC stack.",
+    StackTypes.Boolean | StackTypes.Exec, execIn: 1)]
   public class BooleanVectorIterateExpression : VectorIterateExpression<bool> {
     public BooleanVectorIterateExpression() { }
@@ -110,5 +123,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].ITERATE", StackTypes.String | StackTypes.Exec, execIn: 1)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].ITERATE",
+    "Iterates in reverse order (due to performance reasons) over the top STRING[] using the top item of the EXEC stack.",
+    StackTypes.String | StackTypes.Exec, execIn: 1)]
   public class StringVectorIterateExpression : VectorIterateExpression<string> {
     public StringVectorIterateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15032)
@@ -28,5 +28,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].LAST", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].LAST",
+    "Gets the last item from the top INTEGER[].",
+    StackTypes.Integer)]
   public class IntegerVectorLastExpression : VectorLastExpression<long> {
     public IntegerVectorLastExpression() { }
@@ -44,5 +48,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].LAST", StackTypes.Float)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].LAST",
+    "Gets the last item from the top FLOAT[].",
+    StackTypes.Float)]
   public class FloatVectorLastExpression : VectorLastExpression<double> {
     public FloatVectorLastExpression() { }
@@ -60,5 +68,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].LAST", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].LAST",
+    "Gets the last item from the top BOOLEAN[].",
+    StackTypes.Boolean)]
   public class BooleanVectorLastExpression : VectorLastExpression<bool> {
     public BooleanVectorLastExpression() { }
@@ -76,5 +88,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].LAST", StackTypes.String)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].LAST",
+    "Gets the last item from the top STRING[].",
+    StackTypes.String)]
   public class StringVectorLastExpression : VectorLastExpression<string> {
     public StringVectorLastExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15032)
@@ -28,5 +28,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].LENGTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].LENGTH",
+    "Pushes the length of the top INTEGER[] on the INTEGER stack",
+    StackTypes.Integer)]
   public class IntegerVectorLengthExpression : VectorLengthExpression<long> {
     public IntegerVectorLengthExpression() { }
@@ -44,5 +48,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].LENGTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].LENGTH",
+    "Pushes the length of the top FLOAT[] on the INTEGER stack",
+    StackTypes.Integer)]
   public class FloatVectorLengthExpression : VectorLengthExpression<double> {
     public FloatVectorLengthExpression() { }
@@ -60,5 +68,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].LENGTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].LENGTH",
+    "Pushes the length of the top BOOLEAN[] on the INTEGER stack",
+    StackTypes.Integer)]
   public class BooleanVectorLengthExpression : VectorLengthExpression<bool> {
     public BooleanVectorLengthExpression() { }
@@ -76,5 +88,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].LENGTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].LENGTH",
+    "Pushes the length of the top STRING[] on the INTEGER stack",
+    StackTypes.Integer)]
   public class StringVectorLengthExpression : VectorLengthExpression<string> {
     public StringVectorLengthExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15032)
@@ -42,5 +42,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].NTH", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].NTH",
+    "Pushes the nth item from the top INTEGER[] onto the INTEGER stack, whereby n is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   public class IntegerVectorNthExpression : VectorNthExpression<long> {
     public IntegerVectorNthExpression() { }
@@ -58,5 +62,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].NTH", StackTypes.Float | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].NTH",
+    "Pushes the nth item from the top FLOAT[] onto the FLOAT stack, whereby n is taken from the INTEGER stack.",
+    StackTypes.Float | StackTypes.Integer)]
   public class FloatVectorNthExpression : VectorNthExpression<double> {
     public FloatVectorNthExpression() { }
@@ -74,5 +82,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].NTH", StackTypes.Boolean | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].NTH",
+    "Pushes the nth item from the top BOOLEAN[] onto the BOOLEAN stack, whereby n is taken from the INTEGER stack.",
+    StackTypes.Boolean | StackTypes.Integer)]
   public class BooleanVectorNthExpression : VectorNthExpression<bool> {
     public BooleanVectorNthExpression() { }
@@ -90,5 +102,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].NTH", StackTypes.String | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].NTH",
+    "Pushes the nth item from the top STRING[] onto the BOOLEAN stack, whereby n is taken from the INTEGER stack.",
+    StackTypes.String | StackTypes.Integer)]
   public class StringVectorNthExpression : VectorNthExpression<string> {
     public StringVectorNthExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15032)
@@ -40,5 +40,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].OCCURRENCEOF", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].OCCURRENCEOF",
+    "Pushes the amount of occurrences of the top INTEGER in the top INTEGER[] onto the INTEGER stack.",
+    StackTypes.Integer)]
   public class IntegerVectorOccurrenceOfExpression : VectorOccurrenceOfExpression<long> {
     public IntegerVectorOccurrenceOfExpression() { }
@@ -56,5 +60,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].OCCURRENCEOF", StackTypes.Float | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].OCCURRENCEOF",
+    "Pushes the amount of occurrences of the top FLOAT in the top FLOAT[] onto the INTEGER stack.",
+    StackTypes.Float | StackTypes.Integer)]
   public class FloatVectorOccurrenceOfExpression : VectorOccurrenceOfExpression<double> {
     public FloatVectorOccurrenceOfExpression() { }
@@ -72,5 +80,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].OCCURRENCEOF", StackTypes.Boolean | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].OCCURRENCEOF",
+    "Pushes the amount of occurrences of the top BOOLEAN in the top BOOLEAN[] onto the INTEGER stack.",
+    StackTypes.Boolean | StackTypes.Integer)]
   public class BooleanVectorOccurrenceOfExpression : VectorOccurrenceOfExpression<bool> {
     public BooleanVectorOccurrenceOfExpression() { }
@@ -88,5 +100,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].OCCURRENCEOF", StackTypes.String | StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].OCCURRENCEOF",
+    "Pushes the amount of occurrences of the top STRING in the top STRING[] onto the INTEGER stack.",
+    StackTypes.String | StackTypes.Integer)]
   public class StringVectorOccurrenceOfExpression : VectorOccurrenceOfExpression<string> {
     public StringVectorOccurrenceOfExpression() { }
